using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Demo
{
	/// <summary>
 /// Summary description for DmoOpen.
	/// </summary>
 internal class DmoOpen : System.Windows.Forms.Form
	{
  private Demo dm;
  private int  CurCtl;  // current control index

		private System.Windows.Forms.Button OK;
		private System.Windows.Forms.Button Cancel;
 	private System.Windows.Forms.GroupBox groupBox1;
 	private System.Windows.Forms.GroupBox groupBox2;
 	private System.Windows.Forms.Label label1;
 	private System.Windows.Forms.Label label2;
 	private System.Windows.Forms.Label label3;
 	private System.Windows.Forms.Label label4;
 	private System.Windows.Forms.TextBox InitX;
 	private System.Windows.Forms.TextBox InitY;
 	private System.Windows.Forms.TextBox InitWidth;
 	private System.Windows.Forms.TextBox InitHeight;
 	private System.Windows.Forms.GroupBox groupBox3;
 	private System.Windows.Forms.CheckBox FittedView;
 	private System.Windows.Forms.CheckBox VertScrollBar;
 	private System.Windows.Forms.CheckBox HorzScrollBar;
 	private System.Windows.Forms.CheckBox ShowMenu;
 	private System.Windows.Forms.CheckBox BorderMargin;
 	private System.Windows.Forms.GroupBox groupBox4;
 	private System.Windows.Forms.TextBox file;
 	private System.Windows.Forms.CheckBox EditMode;
 	private System.Windows.Forms.CheckBox TransferAsBuffer;
  
  /// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

  public DmoOpen(Demo parent)
		{
     dm=parent;           // set the parent class
     CurCtl=dm.CurCtl;

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.OK = new System.Windows.Forms.Button();
			this.Cancel = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.file = new System.Windows.Forms.TextBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.EditMode = new System.Windows.Forms.CheckBox();
			this.BorderMargin = new System.Windows.Forms.CheckBox();
			this.ShowMenu = new System.Windows.Forms.CheckBox();
			this.HorzScrollBar = new System.Windows.Forms.CheckBox();
			this.VertScrollBar = new System.Windows.Forms.CheckBox();
			this.FittedView = new System.Windows.Forms.CheckBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.InitHeight = new System.Windows.Forms.TextBox();
			this.InitWidth = new System.Windows.Forms.TextBox();
			this.InitY = new System.Windows.Forms.TextBox();
			this.InitX = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.TransferAsBuffer = new System.Windows.Forms.CheckBox();
			this.groupBox1.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// OK
			// 
			this.OK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.OK.Location = new System.Drawing.Point(208, 328);
			this.OK.Name = "OK";
			this.OK.Size = new System.Drawing.Size(80, 24);
			this.OK.TabIndex = 4;
			this.OK.Text = "OK";
			this.OK.Click += new System.EventHandler(this.OK_Click);
			// 
			// Cancel
			// 
			this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.Cancel.Location = new System.Drawing.Point(296, 328);
			this.Cancel.Name = "Cancel";
			this.Cancel.Size = new System.Drawing.Size(80, 24);
			this.Cancel.TabIndex = 5;
			this.Cancel.Text = "Cancel";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.groupBox4);
			this.groupBox1.Controls.Add(this.groupBox3);
			this.groupBox1.Controls.Add(this.groupBox2);
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(368, 320);
			this.groupBox1.TabIndex = 6;
			this.groupBox1.TabStop = false;
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.file);
			this.groupBox4.Location = new System.Drawing.Point(8, 264);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(344, 48);
			this.groupBox4.TabIndex = 2;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "HTML or RTF File to open";
			// 
			// file
			// 
			this.file.Location = new System.Drawing.Point(8, 16);
			this.file.Name = "file";
			this.file.Size = new System.Drawing.Size(328, 20);
			this.file.TabIndex = 0;
			this.file.Text = "";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.TransferAsBuffer);
			this.groupBox3.Controls.Add(this.EditMode);
			this.groupBox3.Controls.Add(this.BorderMargin);
			this.groupBox3.Controls.Add(this.ShowMenu);
			this.groupBox3.Controls.Add(this.HorzScrollBar);
			this.groupBox3.Controls.Add(this.VertScrollBar);
			this.groupBox3.Controls.Add(this.FittedView);
			this.groupBox3.Location = new System.Drawing.Point(8, 104);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(344, 152);
			this.groupBox3.TabIndex = 1;
			this.groupBox3.TabStop = false;
			// 
			// EditMode
			// 
			this.EditMode.Location = new System.Drawing.Point(8, 128);
			this.EditMode.Name = "EditMode";
			this.EditMode.Size = new System.Drawing.Size(200, 16);
			this.EditMode.TabIndex = 11;
			this.EditMode.Text = "Edit Mode";
			// 
			// BorderMargin
			// 
			this.BorderMargin.Location = new System.Drawing.Point(8, 48);
			this.BorderMargin.Name = "BorderMargin";
			this.BorderMargin.Size = new System.Drawing.Size(192, 16);
			this.BorderMargin.TabIndex = 10;
			this.BorderMargin.Text = "Display margin space around text box";
			// 
			// ShowMenu
			// 
			this.ShowMenu.Location = new System.Drawing.Point(8, 96);
			this.ShowMenu.Name = "ShowMenu";
			this.ShowMenu.Size = new System.Drawing.Size(144, 16);
			this.ShowMenu.TabIndex = 9;
			this.ShowMenu.Text = "Show Menu";
			// 
			// HorzScrollBar
			// 
			this.HorzScrollBar.Location = new System.Drawing.Point(8, 32);
			this.HorzScrollBar.Name = "HorzScrollBar";
			this.HorzScrollBar.Size = new System.Drawing.Size(144, 16);
			this.HorzScrollBar.TabIndex = 5;
			this.HorzScrollBar.Text = "Horizontal Scroll Bar";
			// 
			// VertScrollBar
			// 
			this.VertScrollBar.Location = new System.Drawing.Point(8, 16);
			this.VertScrollBar.Name = "VertScrollBar";
			this.VertScrollBar.Size = new System.Drawing.Size(144, 16);
			this.VertScrollBar.TabIndex = 4;
			this.VertScrollBar.Text = "Vertical Scroll Bar";
			// 
			// FittedView
			// 
			this.FittedView.Location = new System.Drawing.Point(8, 80);
			this.FittedView.Name = "FittedView";
			this.FittedView.Size = new System.Drawing.Size(144, 16);
			this.FittedView.TabIndex = 3;
			this.FittedView.Text = "Fitted View Mode";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.InitHeight);
			this.groupBox2.Controls.Add(this.InitWidth);
			this.groupBox2.Controls.Add(this.InitY);
			this.groupBox2.Controls.Add(this.InitX);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Location = new System.Drawing.Point(8, 16);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(344, 80);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			// 
			// InitHeight
			// 
			this.InitHeight.Location = new System.Drawing.Point(192, 46);
			this.InitHeight.Name = "InitHeight";
			this.InitHeight.Size = new System.Drawing.Size(40, 20);
			this.InitHeight.TabIndex = 7;
			this.InitHeight.Text = "";
			// 
			// InitWidth
			// 
			this.InitWidth.Location = new System.Drawing.Point(192, 16);
			this.InitWidth.Name = "InitWidth";
			this.InitWidth.Size = new System.Drawing.Size(40, 20);
			this.InitWidth.TabIndex = 6;
			this.InitWidth.Text = "";
			// 
			// InitY
			// 
			this.InitY.Location = new System.Drawing.Point(56, 46);
			this.InitY.Name = "InitY";
			this.InitY.Size = new System.Drawing.Size(40, 20);
			this.InitY.TabIndex = 5;
			this.InitY.Text = "";
			// 
			// InitX
			// 
			this.InitX.Location = new System.Drawing.Point(56, 16);
			this.InitX.Name = "InitX";
			this.InitX.Size = new System.Drawing.Size(40, 20);
			this.InitX.TabIndex = 4;
			this.InitX.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(152, 48);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(48, 16);
			this.label4.TabIndex = 3;
			this.label4.Text = "Height";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(152, 18);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(48, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Width";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(48, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Initial Y";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Initial X";
			// 
			// TransferAsBuffer
			// 
			this.TransferAsBuffer.Location = new System.Drawing.Point(8, 64);
			this.TransferAsBuffer.Name = "TransferAsBuffer";
			this.TransferAsBuffer.Size = new System.Drawing.Size(184, 16);
			this.TransferAsBuffer.TabIndex = 12;
			this.TransferAsBuffer.Text = "Transfer the file as a Buffer";
			// 
			// DmoOpen
			// 
			this.AcceptButton = this.OK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.Cancel;
			this.ClientSize = new System.Drawing.Size(384, 357);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.Cancel);
			this.Controls.Add(this.OK);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DmoOpen";
			this.Text = "Open Parameters for a New TE Window";
			this.Load += new System.EventHandler(this.DmoOpen_Load);
			this.Activated += new System.EventHandler(this.DmoOpen_Activated);
			this.groupBox1.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

  private void DmoOpen_Load(object sender, System.EventArgs ev)
  {
    Demo.StrCtl param;

    param=dm.ctl[CurCtl];       // copy of the parameter structure

    InitX.Text=param.x.ToString();              // x location
    InitY.Text=param.y.ToString();              // y location
    InitWidth.Text=param.width.ToString();      // width of the control
    InitHeight.Text=param.height.ToString();    // height of the control
    
    FittedView.Checked=param.FittedView;        // fitted view mode
    VertScrollBar.Checked=param.VertScrollBar;  // show vertical toolbar
    HorzScrollBar.Checked=param.HorzScrollBar;  // show the horizontal scroll bar
    ShowMenu.Checked=param.ShowMenu;            // show the menu bar
    BorderMargin.Checked=param.BorderMargin;    // create the border margin
    EditMode.Checked=param.EditMode;
    TransferAsBuffer.Checked=(param.InputType=='B');

    file.Text=param.file;
  }
  private void DmoOpen_Activated(object sender, System.EventArgs e)
  {
    file.Focus();
  }
  
  private void OK_Click(object sender, System.EventArgs ev)
		{
    Demo.StrCtl param;
    param=dm.ctl[CurCtl];       // make a local copy

    param.x=ToInt(InitX);
    param.y=ToInt(InitY);
    param.width=ToInt(InitWidth);
    param.height=ToInt(InitHeight);
    
    param.FittedView=FittedView.Checked;        // fitted view mode
    param.VertScrollBar=VertScrollBar.Checked;  // show vertical toolbar
    param.HorzScrollBar=HorzScrollBar.Checked;  // show the horizontal scroll bar
    param.ShowMenu=ShowMenu.Checked;            // show the menu bar
    param.BorderMargin=BorderMargin.Checked;    // create the border margin
    param.EditMode=EditMode.Checked;            // edit or view mode
    if (TransferAsBuffer.Checked) param.InputType='B';
    else                          param.InputType='F';

    param.file=file.Text;                       // file name to open
  
    param.InUse=true;                           // this slot is in use now
    param.toc=null;                             // TE object
    param.htn=null;                             // HTML add-on object
    param.form=null;                            // form containing TE object

    dm.ctl[CurCtl]=param;                       // pass updated information
  }

  ////////////////////////////////////////////////////////////////////////////////////////
  //////////// Helper functions
  ////////////////////////////////////////////////////////////////////////////////////////
  /***************************************************************************
      ToInt:
      Convert string to integer
  ****************************************************************************/
  internal new int ToInt(TextBox item)
  {
     return ToInt(item.Text);
  }
  internal new int ToInt(string txt)
  {
     try {
        return (int)Convert.ToInt32(txt);
     } 
     catch (System.Exception)
     {
        return 0;
     }
  } 


	}
}
